@echo off

:goto aggr

:	The build.bat file generates the GTAP dataset 
:	(gtap4001.zip) from the GTAP trade data. 
:
:	The GTAP data (gsddat.har) needs to be placed in ..\data\
:
:	For more information, see readme.txt in this archive or
:	http://debreu.colorado.edu/download/gtap-eg.html
:
:	Thomas Rutherford and Sergey Paltsev
:	rutherford@colorado.edu
:	November 1999

if exist ..\data\gtap001.zip goto here

if exist ..\data\gsddat.har goto start

echo	Error: cannot find ..\data\gsddat.har
echo.
echo	You need to contact GTAP to obtain this file.
echo.
echo	For more information see README.TXT
echo.
goto end

:start

echo	Convert gsddat.har into ..\data\gtap.gms:

:pause
echo	gm3>seehar.inp
echo.>>seehar.inp
echo	..\data\gsddat.har>>seehar.inp
echo	..\data\gsddat.gms>>seehar.inp
echo	r>>seehar.inp
seehar -sti seehar.inp

echo	Use GAMS to relabel, scale, and create ..\data\gtap.zip:
echo	Takes some time! Be patient!
echo.
:pause
call gams relabel

:filter
echo	Use GAMS to filter, recalibrate, and create gtap001.zip:
echo.
:pause
echo	$setglobal tolerance 001  >filter.inc

call gams filter

:erase
:echo	I am about to delete large work files!
echo.
:pause
del ..\data\gsddat.gms
del ..\data\gtap.zip

echo	The GTAPinGAMS dataset is in ..\data\gtap001.zip
echo.	
goto end

:aggr
echo	Will now aggregate the ..\data\gtap001.zip to produce ..\data\gtap_small.zip
echo.	
echo	It will replace the existing aggregated dataset (gtap_small.zip). 
echo	Press Ctrl-C to cancel, or
pause
call gtapaggr gtap_small
goto end

:here
echo.
echo	You already have the GTAPinGAMS dataset.
echo.	
echo	If you want to rebuild it, delete the file GTAP001.ZIP
echo	from the DATA subdirectory, and run BUILD.BAT again.
echo.

:end