$if not setglobal debug $offlisting

$version 93

$hidden MODHAR: Data export routine to produce a GEMPACK header array file 

$hidden Requires the GEMPACK utility program MODHAR.EXE (5-26-1998 or later)

$hidden Usage:

$hidden         $libinclude modhar file item1 domain1 item2 domain2 ...[&]

$hidden		"&" indicates continuation.  For example, suppose that 
$hidden		we have parameter a(i), b(i,j,k) and c(i,j,k).  The statement:

$hidden		$libinclude modhar newhar   a i   b i j   c i j k

$hidden		is equivalent to the statement:

$hidden		$libinclude modhar newhar   a i   &
$hidden		$libinclude modhar newhar   b i j &
$hidden		$libinclude modhar newhar   c i j k


$if declared mh_h $goto begin

*       GAMS declarations are here -- a blank invocation initializes to permit
*       invocation from inside a loop:

set     mh_h    Counter on parameter headers /h000*h999/, mh_hc(mh_h) /h000/,
        mh_s    Counter on sets              /s000*s999/, mh_sc(mh_s)   /s000/,

*       Dummy sets used to avoid the use of alias set arguments, 
*       for example with arrays declared a(i,i):

        mh_i1(*),mh_i2(*),mh_i3(*), mh_i4(*), mh_i5(*), mh_i6(*), mh_i7(*);

parameter  mh_sets(*);

alias   (mh_u,*)

file mh_cmd     MODHAR command file /%gams.scrdir%mh_cmd.scr/; 
file mh_dat     Parameter data file /%gams.scrdir%mh_dat.scr/; 
file mh_set     Set definition file /%gams.scrdir%mh_set.scr/; 

mh_cmd.lw = 0; mh_dat.lw = 0; mh_set.lw = 0;
mh_cmd.pw = 256; mh_dat.pw = 256; mh_set.pw = 256;

$setglobal mh_file none

$log --- Note: MODHAR log file will be written to modhar.log.


$if "%1"=="" $exit

$label begin

*       Read all the local $set statements which have been saved 
*       on the external file:

$if %mh_file%==none $goto newfile

mh_dat.ap=1; 
mh_set.ap=1; 
$goto start

$label newfile

*       Reset counters on sets and parameters:

mh_dat.ap = 0;  
mh_set.ap = 0;
mh_sets(mh_u) = no;
mh_hc(mh_h) = no; 
mh_hc("h000") = yes;
mh_sc(mh_s) = no; 
mh_sc("s000") = yes;
$setglobal mh_file %1
$shift

*       Branch to this point after each item has been written:

$label start
$if not "%1"=="" $goto write_par

execute 'if exist modhar.log del modhar.log';

*       If any sets have been passed then load them first:

if (not mh_sc("s000"),

  putclose mh_set; 
  putclose mh_cmd,'bat'//'n'/'%gams.scrdir%sets_har.scr'/'at'/
                        '%gams.scrdir%mh_set.scr'/'a'/'ex'/'0'/;
*.  execute '%gams.sdir%modhar <%gams.scrdir%mh_cmd.scr >>modhar.log';
*.  execute '%gams.sdir%modhar -sti %gams.scrdir%mh_cmd.scr -lon modhar.log';
  execute 'modhar -sti %gams.scrdir%mh_cmd.scr -lon modhar.log';

);

*       If any parameter data have been generated, move it out:

if (not mh_hc("h000"),

  putclose mh_dat;

  if (not mh_sc("s000"),
    putclose mh_cmd, 'bat'//'n'/'%mh_file%.har'/'ds'/
                '%gams.scrdir%sets_har.scr'/'a'/'at'/
                '%gams.scrdir%mh_dat.scr'/'a'/'ex'/'0'/;
  else
    putclose mh_cmd, 'bat'//'n'/'%mh_file%.har'/'at'/
                '%gams.scrdir%mh_dat.scr'/'a'/'ex'/'0'/;
  );
*.  execute '%gams.sdir%modhar <%gams.scrdir%mh_cmd.scr >>modhar.log';
*.  execute '%gams.sdir%modhar -sti %gams.scrdir%mh_cmd.scr -lon modhar.log';
  execute 'modhar -sti %gams.scrdir%mh_cmd.scr -lon modhar.log';

);

*       Set switch that no file is currently active:

$setglobal mh_file none

$exit

$label write_par

*       Continuation switch -- exit without outputting data:

$if "%1"=="&" $exit

*       Increment the counter:

mh_hc(mh_h+1)$mh_hc(mh_h) = yes;
mh_hc(mh_h)$mh_hc(mh_h+1) = no;

$if not partype %1 $abort "Error: argument sequence error in modhar. %1 is not a parameter."

put mh_dat;

$if dimension 0 %1 $goto scalar
$if dimension 1 %1 $goto oned
$if dimension 2 %1 $goto twod
$if dimension 3 %1 $goto threed
$if dimension 4 %1 $goto fourd
$if dimension 5 %1 $goto fived
$if dimension 6 %1 $goto sixd
$if dimension 7 %1 $goto sevend

$abort "Error: parameter domain dimension exceeds seven."

$label scalar
file.nr=0;file.nw=6;file.nd=0;
$set name %1
$if "%2"=="-n" $set name %3
loop(mh_hc,
  put '  1 col_order header "%name%';
  if (file.cc gt 27, put '  1 col_order header "',mh_hc.tl;);
*  put  '  1 col_order header "',mh_hc.tl,'" longname "%name%"'/'     coefficient %name%;'/;
  put '" longname "%name%"'/'     coefficient %name%;'/;
);
file.nr=2;file.nw=16;file.nd=8;
put %1 ' ! scalar value'/;

*       A shift disposes of the parameter.

$shift
$if "%1"=="-n" $shift shift
$goto start

$label oned
$if not settype %2 $abort "Error: argument sequence error in modhar. %2 is not a set."
file.nr=0;file.nw=6;file.nd=0;
$set name %1
$if "%3"=="-n" $set name %4
loop(mh_hc,
  put card(%2),' col_order header "%name%';
  if (file.cc gt 30, put @0 card(%2),' col_order header "',mh_hc.tl;);
  put   '" longname "%name%(%2)"'/ ' coefficient %name%(%2);'/;

*.  put card(%2),' col_order header "',mh_hc.tl,'" longname "%name%(%2)"'/
*.               '     coefficient %name%(%2);'/;

  );
$onuni
file.nr=2;file.nw=16;file.nd=8;
loop(%2,
  put %1(%2),' ! ', %2.tl/;);
$offuni
$if not exist ..\inclib\mhset.gms $libinclude mhset %2
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %2

*       Two shifts dispose of the parameter and one set arguments:

$shift
$shift
$if "%1"=="-n" $shift shift
$goto start


$label twod
$if not settype %2 $abort "Error: argument sequence error in modhar. %2 is not a set."
$if not settype %3 $abort "Error: argument sequence error in modhar. %3 is not a set."
file.nr=0;file.nw=6;file.nd=0;
$set name %1
$if "%4"=="-n" $set name %5
loop(mh_hc,

  put card(%2),card(%3),' col_order header "%name%';
  if (file.cc gt 36, put @0 card(%2),card(%3),' col_order header "',mh_hc.tl;);

  put   '" longname "%name%(%2,%3)"'/'     coefficient %name%(%2,%3);'/;

*.  put card(%2),card(%3),
*.      ' col_order header "',mh_hc.tl,'" longname "%name%(%2,%3)"'/
*.      '     coefficient %name%(%2,%3);'/;

);
file.nr=2;file.nw=16;file.nd=8;
mh_i1(%2) = yes;
mh_i2(%3) = yes;
$onuni
loop(mh_i2,loop(mh_i1, 
        put %1(mh_i1,mh_i2),' ! ',
        mh_i1.tl,'.',mh_i2.tl/;));
$offuni
mh_i1(%2) = no;
mh_i2(%3) = no;
$if not exist ..\inclib\mhset.gms $libinclude mhset %2
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %2
$if not exist ..\inclib\mhset.gms $libinclude mhset %3
$if     exist ..\inclib\hset.gms $batinclude ..\inclib\mhset %3

*       Three shifts dispose of the parameter and two set arguments:

$shift
$shift
$shift
$if "%1"=="-n" $shift shift
$goto start

$label threed
$if not settype %2 $abort "Error: argument sequence error in modhar. %2 is not a set."
$if not settype %3 $abort "Error: argument sequence error in modhar. %3 is not a set."
$if not settype %4 $abort "Error: argument sequence error in modhar. %4 is not a set."
file.nr=0;file.nw=6;file.nd=0;
$set name %1
$if "%5"=="-n" $set name %6
loop(mh_hc,
  put card(%2),card(%3),card(%4),' col_order header "%name%';
  if (file.cc gt 42, put @0 card(%2),card(%3),card(%4),' col_order header "',mh_hc.tl;);
  put '" longname "%name%(%2,%3,%4)"'/'     coefficient %name%(%2,%3,%4);'/;

*.  put card(%2),card(%3),card(%4),
*.      ' col_order header "',mh_hc.tl,'" longname "%name%(%2,%3,%4)"'/
*.      '     coefficient %name%(%2,%3,%4);'/;

);
file.nr=2;file.nw=16;file.nd=8;
mh_i1(%2) = yes;
mh_i2(%3) = yes;
mh_i3(%4) = yes;
$onuni
loop(mh_i3,loop(mh_i2,loop(mh_i1, 
        put %1(mh_i1,mh_i2,mh_i3),' ! ',
        mh_i1.tl,'.',mh_i2.tl,'.',mh_i3.tl/;)));
$offuni
mh_i1(%2) = no;
mh_i2(%3) = no;
mh_i3(%4) = no;
$if not exist ..\inclib\mhset.gms $libinclude mhset %2
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %2
$if not exist ..\inclib\mhset.gms $libinclude mhset %3
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %3
$if not exist ..\inclib\mhset.gms $libinclude mhset %4
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %4

*       Four shifts dispose of the parameter and three set arguments:


$shift
$shift
$shift
$shift
$if "%1"=="-n" $shift shift
$goto start

$label fourd
$if not settype %2 $abort "Error: argument sequence error in modhar. %2 is not a set."
$if not settype %3 $abort "Error: argument sequence error in modhar. %3 is not a set."
$if not settype %4 $abort "Error: argument sequence error in modhar. %4 is not a set."
$if not settype %5 $abort "Error: argument sequence error in modhar. %5 is not a set."

file.nr=0;file.nw=6;file.nd=0;
$set name %1
$if "%6"=="-n" $set name %7
loop(mh_hc,
  put card(%2),card(%3),card(%4),card(%5),' col_order header "%name%';
  if (file.cc gt 48, put @0 card(%2),card(%3),card(%4),card(%5),' col_order header "',mh_hc.tl;);
  put '" longname "%name%(%2,%3,%4,%5)"'/'     coefficient %name%(%2,%3,%4,%5);'/;
*.  put card(%2),card(%3),card(%4),card(%5),
*.      ' col_order header "',mh_hc.tl,'" longname "%1(%2,%3,%4,%5)"'/
*.      '     coefficient %1(%2,%3,%4,%5);'/;
);
file.nr=2;file.nw=16;file.nd=8;
mh_i1(%2) = yes;
mh_i2(%3) = yes;
mh_i3(%4) = yes;
mh_i4(%5) = yes;
$onuni
loop(mh_i4,loop(mh_i3,loop(mh_i2,loop(mh_i1, 
        put %1(mh_i1,mh_i2,mh_i3,mh_i4),' ! ',
        mh_i1.tl,'.',mh_i2.tl,'.',mh_i3.tl,'.',mh_i4.tl/;))));
$offuni
mh_i1(%2) = no;
mh_i2(%3) = no;
mh_i3(%4) = no;
mh_i4(%5) = no;
$if not exist ..\inclib\mhset.gms $libinclude mhset %2
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %2
$if not exist ..\inclib\mhset.gms $libinclude mhset %3
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %3
$if not exist ..\inclib\mhset.gms $libinclude mhset %4
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %4
$if not exist ..\inclib\mhset.gms $libinclude mhset %5
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %5

*       Five shifts dispose of the parameter and four set arguments:

$shift
$shift
$shift
$shift
$shift
$if "%1"=="-n" $shift shift
$goto start

$label fived
$if not settype %2 $abort "Error: argument sequence error in modhar. %2 is not a set."
$if not settype %3 $abort "Error: argument sequence error in modhar. %3 is not a set."
$if not settype %4 $abort "Error: argument sequence error in modhar. %4 is not a set."
$if not settype %5 $abort "Error: argument sequence error in modhar. %5 is not a set."
$if not settype %6 $abort "Error: argument sequence error in modhar. %6 is not a set."

file.nr=0;file.nw=6;file.nd=0;
$set name %1
$if "%7"=="-n" $set name %8
loop(mh_hc,
  put card(%2),card(%3),card(%4),card(%5),card(%6),' col_order header "%name%';
  if (file.cc gt 54, put @0 card(%2),card(%3),card(%4),card(%5),card(%6),' col_order header "',mh_hc.tl;);
  put '" longname "%name%(%2,%3,%4,%5,%6)"'/'     coefficient %name%(%2,%3,%4,%5,%6);'/;

*.  put card(%2),card(%3),card(%4),card(%5),card(%6),
*.      ' col_order header "',mh_hc.tl,'" longname "%1(%2,%3,%4,%5,%6)"'/
*.      '     coefficient %1(%2,%3,%4,%5,%6);'/;

);
file.nr=2;file.nw=16;file.nd=8;
mh_i1(%2) = yes;
mh_i2(%3) = yes;
mh_i3(%4) = yes;
mh_i4(%5) = yes;
mh_i5(%6) = yes;
$onuni
loop(mh_i5,loop(mh_i4,loop(mh_i3,loop(mh_i2,loop(mh_i1, 
        put %1(mh_i1,mh_i2,mh_i3,mh_i4,mh_i5),' ! ',
        mh_i1.tl,'.',mh_i2.tl,'.',mh_i3.tl,'.',mh_i4.tl,'.',mh_i5.tl/;)))));
$offuni
mh_i1(%2) = no;
mh_i2(%3) = no;
mh_i3(%4) = no;
mh_i4(%5) = no;
mh_i5(%6) = no;
$if not exist ..\inclib\mhset.gms $libinclude mhset %2
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %2
$if not exist ..\inclib\mhset.gms $libinclude mhset %3
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %3
$if not exist ..\inclib\mhset.gms $libinclude mhset %4
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %4
$if not exist ..\inclib\mhset.gms $libinclude mhset %5
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %5
$if not exist ..\inclib\mhset.gms $libinclude mhset %6
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %6

*       Six shifts dispose of the parameter and five set arguments:

$shift
$shift
$shift
$shift
$shift
$shift
$if "%1"=="-n" $shift shift
$goto start

$label sixd
$if not settype %2 $abort "Error: argument sequence error in modhar. %2 is not a set."
$if not settype %3 $abort "Error: argument sequence error in modhar. %3 is not a set."
$if not settype %4 $abort "Error: argument sequence error in modhar. %4 is not a set."
$if not settype %5 $abort "Error: argument sequence error in modhar. %5 is not a set."
$if not settype %6 $abort "Error: argument sequence error in modhar. %6 is not a set."
$if not settype %7 $abort "Error: argument sequence error in modhar. %7 is not a set."

file.nr=0;file.nw=6;file.nd=0;
$set name %1
$if "%8"=="-n" $set name %9
loop(mh_hc,
  put card(%2),card(%3),card(%4),card(%5),card(%6),card(%7),' col_order header "%name%';
  if (file.cc gt 60, put @0 card(%2),card(%3),card(%4),card(%5),card(%6),card(%7),' col_order header "',mh_hc.tl;);
  put '" longname "%name%(%2,%3,%4,%5,%6,%7)"'/'     coefficient %name%(%2,%3,%4,%5,%6,%7);'/;

*.  put card(%2),card(%3),card(%4),card(%5),card(%6), card(%7),
*.      ' col_order header "',mh_hc.tl,'" longname "%1(%2,%3,%4,%5,%6,%7)"'/
*.      '     coefficient %1(%2,%3,%4,%5,%6,%7);'/;

);
file.nr=2;file.nw=16;file.nd=8;
mh_i1(%2) = yes;
mh_i2(%3) = yes;
mh_i3(%4) = yes;
mh_i4(%5) = yes;
mh_i5(%6) = yes;
mh_i6(%7) = yes;
$onuni
loop(mh_i6,loop(mh_i5,loop(mh_i4,loop(mh_i3,loop(mh_i2,loop(mh_i1, 
        put %1(mh_i1,mh_i2,mh_i3,mh_i4,mh_i5,mh_i6),' ! ',
        mh_i1.tl,'.',mh_i2.tl,'.',mh_i3.tl,'.',mh_i4.tl,'.',mh_i5.tl,'.',mh_i6.tl/;))))));
$offuni
mh_i1(%2) = no;
mh_i2(%3) = no;
mh_i3(%4) = no;
mh_i4(%5) = no;
mh_i5(%6) = no;
mh_i6(%7) = no;
$if not exist ..\inclib\mhset.gms $libinclude mhset %2
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %2
$if not exist ..\inclib\mhset.gms $libinclude mhset %3
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %3
$if not exist ..\inclib\mhset.gms $libinclude mhset %4
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %4
$if not exist ..\inclib\mhset.gms $libinclude mhset %5
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %5
$if not exist ..\inclib\mhset.gms $libinclude mhset %6
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %6
$if not exist ..\inclib\mhset.gms $libinclude mhset %7
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %7

*       Seven shifts dispose of the parameter and six set arguments:

$shift
$shift
$shift
$shift
$shift
$shift
$shift
$if "%1"=="-n" $shift shift
$goto start

$label sevend
$if not settype %2 $abort "Error: argument sequence error in modhar. %2 is not a set."
$if not settype %3 $abort "Error: argument sequence error in modhar. %3 is not a set."
$if not settype %4 $abort "Error: argument sequence error in modhar. %4 is not a set."
$if not settype %5 $abort "Error: argument sequence error in modhar. %5 is not a set."
$if not settype %6 $abort "Error: argument sequence error in modhar. %6 is not a set."
$if not settype %7 $abort "Error: argument sequence error in modhar. %7 is not a set."
$if not settype %8 $abort "Error: argument sequence error in modhar. %8 is not a set."

file.nr=0;file.nw=6;file.nd=0;
$set name %1
$if "%9"=="-n" $set name %10
loop(mh_hc,
  put card(%2),card(%3),card(%4),card(%5),card(%6),card(%7),card(%8),' col_order header "%name%';
  if (file.cc gt 66, put @0 card(%2),card(%3),card(%4),card(%5),card(%6),card(%7),card(%8),' col_order header "',mh_hc.tl;);
  put '" longname "%name%(%2,%3,%4,%5,%6,%7,%8)"'/'     coefficient %name%(%2,%3,%4,%5,%6,%7,%8);'/;

*.  put card(%2),card(%3),card(%4),card(%5),card(%6), card(%7), card(%8),
*.      ' col_order header "',mh_hc.tl,'" longname "%1(%2,%3,%4,%5,%6,%7,%8)"'/
*.      '     coefficient %1(%2,%3,%4,%5,%6,%7,%8);'/;
);
file.nr=2;file.nw=16;file.nd=8;
mh_i1(%2) = yes;
mh_i2(%3) = yes;
mh_i3(%4) = yes;
mh_i4(%5) = yes;
mh_i5(%6) = yes;
mh_i6(%7) = yes;
mh_i7(%8) = yes;
$onuni
loop(mh_i7,loop(mh_i6,loop(mh_i5,loop(mh_i4,loop(mh_i3,loop(mh_i2,loop(mh_i1, 
        put %1(mh_i1,mh_i2,mh_i3,mh_i4,mh_i5,mh_i6,mh_i7),' ! ',
        mh_i1.tl,'.',mh_i2.tl,'.',mh_i3.tl,'.',mh_i4.tl,'.',
        mh_i5.tl,'.',mh_i6.tl,'.',mh_i7.tl/;)))))));
$offuni
mh_i1(%2) = no;
mh_i2(%3) = no;
mh_i3(%4) = no;
mh_i4(%5) = no;
mh_i5(%6) = no;
mh_i6(%7) = no;
mh_i7(%8) = no;
$if not exist ..\inclib\mhset.gms $libinclude mhset %2
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %2
$if not exist ..\inclib\mhset.gms $libinclude mhset %3
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %3
$if not exist ..\inclib\mhset.gms $libinclude mhset %4
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %4
$if not exist ..\inclib\mhset.gms $libinclude mhset %5
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %5
$if not exist ..\inclib\mhset.gms $libinclude mhset %6
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %6
$if not exist ..\inclib\mhset.gms $libinclude mhset %7
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %7
$if not exist ..\inclib\mhset.gms $libinclude mhset %8
$if     exist ..\inclib\mhset.gms $batinclude ..\inclib\mhset %8


*       Eight shifts dispose of the parameter and seven set arguments:

$shift
$shift
$shift
$shift
$shift
$shift
$shift
$shift
$if "%1"=="-n" $shift shift
$goto start
